Index: /rtos_arduino/trunk/examples/BlueMix_basic/rca_app.cpp
===================================================================
--- /rtos_arduino/trunk/examples/BlueMix_basic/rca_app.cpp	(revision 212)
+++ /rtos_arduino/trunk/examples/BlueMix_basic/rca_app.cpp	(revision 213)
@@ -16,9 +16,9 @@
 char password[] = PASSWORD;
 
-ESP8266Client wifi;
-PubSubClient client(serverName, 1883, 0, wifi);
+ESP8266Client wifi_client;
+PubSubClient client(serverName, 1883, 0, wifi_client);
 
-#define SSID            ""
-#define WIFI_PASSWORD   ""
+#define STA_SSID       ""
+#define STA_PASSWORD   ""
 
 void MqttConnect()
@@ -74,5 +74,5 @@
     Serial.println("Echo Server : Start!");
     
-    ret = wifi.begin(Serial5, 115200);
+    ret = WiFi.begin(Serial5, 115200);
 
     if(ret == 1) {
@@ -82,5 +82,5 @@
         Serial.println("FW Version mismatch.");
         Serial.print("FW Version:");
-        Serial.println(wifi.getVersion().c_str());
+        Serial.println(WiFi.getVersion().c_str());
         Serial.print("Supported FW Version:");
         Serial.println(ESP8266_SUPPORT_VERSION);
@@ -91,7 +91,7 @@
 
     Serial.print("FW Version:");
-    Serial.println(wifi.getVersion().c_str());
+    Serial.println(WiFi.getVersion().c_str());
     
-    if (wifi.setOprToStation()) {
+    if (WiFi.setOprToStation()) {
         Serial.print("to station ok\r\n");
     } else {
@@ -99,13 +99,13 @@
     }
     
-    if (wifi.joinAP(SSID, WIFI_PASSWORD)) {
+    if (WiFi.joinAP(STA_SSID, STA_PASSWORD)) {
         Serial.print("Join AP success\r\n");
         Serial.print("IP: ");
-        Serial.println(wifi.getLocalIP().c_str());    
+        Serial.println(WiFi.getLocalIP().c_str());    
     } else {
         Serial.print("Join AP failure\r\n");
     }
     
-    if (wifi.stopServer()) {
+    if (WiFi.stopServer()) {
         Serial.print("Stop server ok\r\n");
     } else {
@@ -113,5 +113,5 @@
     }        
     
-    if (wifi.disableMUX()) {
+    if (WiFi.disableMUX()) {
         Serial.print("single ok\r\n");
     } else {
@@ -121,15 +121,19 @@
     MqttConnect();
     Serial.println("MQTT set up");
-
-    Wire.begin();
-    TSL2561.init();
 }
 
 int cnt = 0;
-
 void loop()
-{
+{    
     MqttRequest(cnt++);
     delay(1000);
     client.loop();
+
+    if (Serial.available() > 0) {
+        Serial.read();
+        Serial.print("Pause  : Input any char to continue.\n\r");
+        while(!(Serial.available() > 0));
+        Serial.print("Resume.\n\r");
+        Serial.read();
+    }
 }
Index: /rtos_arduino/trunk/examples/Milkcocoa_basic/rca_app.cpp
===================================================================
--- /rtos_arduino/trunk/examples/Milkcocoa_basic/rca_app.cpp	(revision 212)
+++ /rtos_arduino/trunk/examples/Milkcocoa_basic/rca_app.cpp	(revision 213)
@@ -4,21 +4,21 @@
 #include "Client_ESP8266.h"
 
-#define SSID       ""
-#define PASSWORD   ""
+#define STA_SSID       ""
+#define STA_PASSWORD   ""
 
 #define MILKCOCOA_APP_ID      ""
 #define MILKCOCOA_DATASTORE   ""
 
-#define MILKCOCOA_PUSH
+//#define MILKCOCOA_PUSH
 #define MILKCOCOA_ON
 
 #define MILKCOCOA_SERVERPORT  1883
 
-ESP8266Client wifi;
+ESP8266Client wifi_client;
 
 const char MQTT_SERVER[] PROGMEM    = MILKCOCOA_APP_ID ".mlkcca.com";
 const char MQTT_CLIENTID[] PROGMEM  = __TIME__ MILKCOCOA_APP_ID;
 
-Milkcocoa milkcocoa = Milkcocoa(&wifi, MQTT_SERVER, MILKCOCOA_SERVERPORT, MILKCOCOA_APP_ID, MQTT_CLIENTID);
+Milkcocoa milkcocoa = Milkcocoa(&wifi_client, MQTT_SERVER, MILKCOCOA_SERVERPORT, MILKCOCOA_APP_ID, MQTT_CLIENTID);
 
 extern void onpush(DataElement *elem);
@@ -34,7 +34,7 @@
     Serial.println(); Serial.println();
     Serial.print("Connecting to ");
-    Serial.println(SSID);
+    Serial.println(STA_SSID);
 
-    ret = wifi.begin(Serial5, 115200);
+    ret = WiFi.begin(Serial5, 115200);
 
     if(ret == 1) {
@@ -44,5 +44,5 @@
         Serial.println("FW Version mismatch.");
         Serial.print("FW Version:");
-        Serial.println(wifi.getVersion().c_str());
+        Serial.println(WiFi.getVersion().c_str());
         Serial.print("Supported FW Version:");
         Serial.println(ESP8266_SUPPORT_VERSION);
@@ -53,7 +53,7 @@
 
     Serial.print("FW Version:");
-    Serial.println(wifi.getVersion().c_str());
+    Serial.println(WiFi.getVersion().c_str());
     
-    if (wifi.setOprToStation()) {
+    if (WiFi.setOprToStation()) {
         Serial.print("to station ok\r\n");
     } else {
@@ -61,13 +61,13 @@
     }
     
-    if (wifi.joinAP(SSID, PASSWORD)) {
+    if (WiFi.joinAP(STA_SSID, STA_PASSWORD)) {
         Serial.print("Join AP success\r\n");
         Serial.print("IP: ");
-        Serial.println(wifi.getLocalIP().c_str());    
+        Serial.println(WiFi.getLocalIP().c_str());    
     } else {
         Serial.print("Join AP failure\r\n");
     }
 
-    if (wifi.stopServer()) {
+    if (WiFi.stopServer()) {
         Serial.print("Stop server ok\r\n");
     } else {
@@ -75,5 +75,5 @@
     }        
     
-    if (wifi.disableMUX()) {
+    if (WiFi.disableMUX()) {
         Serial.print("single ok\r\n");
     } else {
Index: /rtos_arduino/trunk/examples/ThingSpeak_basic/rca_app.cpp
===================================================================
--- /rtos_arduino/trunk/examples/ThingSpeak_basic/rca_app.cpp	(revision 212)
+++ /rtos_arduino/trunk/examples/ThingSpeak_basic/rca_app.cpp	(revision 213)
@@ -4,8 +4,8 @@
 #include "ThingSpeak.h"
 
-#define SSID       ""
-#define PASSWORD   ""
+#define STA_SSID       ""
+#define STA_PASSWORD   ""
 
-ESP8266Client wifi;
+ESP8266Client wifi_client;
 
 void setup()
@@ -19,7 +19,7 @@
     Serial.println(); Serial.println();
     Serial.print("Connecting to ");
-    Serial.println(SSID);
+    Serial.println(STA_SSID);
 
-    ret = wifi.begin(Serial5, 115200);
+    ret = WiFi.begin(Serial5, 115200);
 
     if(ret == 1) {
@@ -29,5 +29,5 @@
         Serial.println("FW Version mismatch.");
         Serial.print("FW Version:");
-        Serial.println(wifi.getVersion().c_str());
+        Serial.println(WiFi.getVersion().c_str());
         Serial.print("Supported FW Version:");
         Serial.println(ESP8266_SUPPORT_VERSION);
@@ -38,7 +38,7 @@
 
     Serial.print("FW Version:");
-    Serial.println(wifi.getVersion().c_str());
+    Serial.println(WiFi.getVersion().c_str());
     
-    if (wifi.setOprToStation()) {
+    if (WiFi.setOprToStation()) {
         Serial.print("to station ok\r\n");
     } else {
@@ -46,13 +46,13 @@
     }
     
-    if (wifi.joinAP(SSID, PASSWORD)) {
+    if (WiFi.joinAP(STA_SSID, STA_PASSWORD)) {
         Serial.print("Join AP success\r\n");
         Serial.print("IP: ");
-        Serial.println(wifi.getLocalIP().c_str());    
+        Serial.println(WiFi.getLocalIP().c_str());    
     } else {
         Serial.print("Join AP failure\r\n");
     }
 
-    if (wifi.stopServer()) {
+    if (WiFi.stopServer()) {
         Serial.print("Stop server ok\r\n");
     } else {
@@ -60,5 +60,5 @@
     }        
     
-    if (wifi.disableMUX()) {
+    if (WiFi.disableMUX()) {
         Serial.print("single ok\r\n");
     } else {
@@ -67,5 +67,5 @@
     
     //Setup
-    if (ThingSpeak.begin(wifi))  {
+    if (ThingSpeak.begin(wifi_client))  {
         Serial.print("ThingSpeak.begin() ok\r\n");
     } else {
@@ -79,5 +79,5 @@
 }
 
-unsigned long myChannelNumber = ;
+unsigned long myChannelNumber = 
 const char * myWriteAPIKey = "";
 int cnt1;
@@ -86,4 +86,5 @@
 void loop() {
     int ret;
+
     ThingSpeak.setField(1,cnt1);
     ThingSpeak.setField(2,cnt2);
Index: /rtos_arduino/trunk/examples/WifiEcho/rca_app.cpp
===================================================================
--- /rtos_arduino/trunk/examples/WifiEcho/rca_app.cpp	(revision 212)
+++ /rtos_arduino/trunk/examples/WifiEcho/rca_app.cpp	(revision 213)
@@ -2,6 +2,6 @@
 #include "ESP8266.h"
 
-#define SSID       ""
-#define PASSWORD   ""
+#define STA_SSID       ""
+#define STA_PASSWORD   ""
 
 #define AP_SSID       "M0_AP"
@@ -9,6 +9,4 @@
 
 #define WMODE_STATION
-
-ESP8266 wifi;
 
 bool setup_done = false;
@@ -20,5 +18,5 @@
     Serial.println("Echo Server : Start!");
     
-    ret = wifi.begin(Serial5, 115200);
+    ret = WiFi.begin(Serial5, 115200);
 
     if(ret == 1) {
@@ -28,5 +26,5 @@
         Serial.println("FW Version mismatch.");
         Serial.print("FW Version:");
-        Serial.println(wifi.getVersion().c_str());
+        Serial.println(WiFi.getVersion().c_str());
         Serial.print("Supported FW Version:");
         Serial.println(ESP8266_SUPPORT_VERSION);
@@ -37,8 +35,8 @@
 
     Serial.print("FW Version:");
-    Serial.println(wifi.getVersion().c_str());
+    Serial.println(WiFi.getVersion().c_str());
     
 #ifdef  WMODE_STATION
-    if (wifi.setOprToStation()) {
+    if (WiFi.setOprToStation()) {
         Serial.print("to station ok\r\n");
     } else {
@@ -46,21 +44,21 @@
     }
     
-    if (wifi.joinAP(SSID, PASSWORD)) {
+    if (WiFi.joinAP(STA_SSID, STA_PASSWORD)) {
         Serial.print("Join AP success\r\n");
         Serial.print("IP: ");
-        Serial.println(wifi.getLocalIP().c_str());    
+        Serial.println(WiFi.getLocalIP().c_str());    
     } else {
         Serial.print("Join AP failure\r\n");
     }
 #else /* !WMODE_STATION */ 
-    if (wifi.setOprToSoftAP()) {
+    if (WiFi.setOprToSoftAP()) {
         Serial.print("to softap ok\r\n");
     } else {
         Serial.print("to softap err\r\n");
     }    
-    if(wifi.setSoftAPParam(AP_SSID, AP_PASSWORD, 7, 0)){
+    if(WiFi.setSoftAPParam(AP_SSID, AP_PASSWORD, 7, 0)){
         Serial.print("Set SoftAP success\r\n");
         Serial.print("IP: ");
-        Serial.println(wifi.getLocalIP().c_str());            
+        Serial.println(WiFi.getLocalIP().c_str());            
     }
     else {
@@ -69,5 +67,5 @@
 #endif /* WMODE_STATION */
     
-    if (wifi.enableMUX()) {
+    if (WiFi.enableMUX()) {
         Serial.print("multiple ok\r\n");
     } else {
@@ -75,5 +73,5 @@
     }
 
-    if (wifi.startTCPServer(80)) {
+    if (WiFi.startTCPServer(80)) {
         Serial.print("start tcp server ok\r\n");
     } else {
@@ -81,5 +79,5 @@
     }
 
-    if (wifi.setTCPServerTimeout(60)) { 
+    if (WiFi.setTCPServerTimeout(60)) { 
         Serial.print("set tcp server timout 60 seconds\r\n");
     } else {
@@ -110,5 +108,5 @@
     pre_mux_id_ptn = mux_id_ptn;
 
-    if(!wifi.getMuxCStatus(&mux_id_ptn)) {
+    if(!WiFi.getMuxCStatus(&mux_id_ptn)) {
         Serial.println("getMuxCStatus(&mux_id_ptn) : Error!");
     }
@@ -130,5 +128,5 @@
     }
     
-    if (!wifi.isConnected(mux_id)) {
+    if (!WiFi.isConnected(mux_id)) {
         Serial.print("Echo Server : Port is closed: ");
         Serial.println(mux_id);
@@ -137,5 +135,5 @@
     }
     
-    if((len = wifi.recv(mux_id, buffer, sizeof(buffer))) == 0) {
+    if((len = WiFi.recv(mux_id, buffer, sizeof(buffer))) == 0) {
         return;
     }
@@ -148,5 +146,5 @@
             Serial.print("Echo Server : Close port : ");
             Serial.println(mux_id);            
-            wifi.releaseTCP(mux_id);
+            WiFi.releaseTCP(mux_id);
             mux_id = MUX_NULL;
             return;
@@ -161,5 +159,5 @@
     Serial.println((char*)buffer);
     
-    if(!wifi.send(mux_id, buffer, len)) {
+    if(!WiFi.send(mux_id, buffer, len)) {
         Serial.println("Echo Server : send(mux_id, cmd) : Error!");
     }
@@ -189,5 +187,5 @@
     }
     
-    if (!wifi.isConnected(task1_mux_id)) {
+    if (!WiFi.isConnected(task1_mux_id)) {
         Serial.print("Echo Server Task1 : Port is closed: ");
         Serial.println(task1_mux_id);
@@ -195,5 +193,5 @@
         return;
     }
-    if((len = wifi.recv(task1_mux_id, buffer, sizeof(buffer))) == 0) {
+    if((len = WiFi.recv(task1_mux_id, buffer, sizeof(buffer))) == 0) {
         return;
     }        
@@ -206,5 +204,5 @@
             Serial.print("Echo Server Task1 : Close port : ");
             Serial.println(task1_mux_id);            
-            wifi.releaseTCP(task1_mux_id);
+            WiFi.releaseTCP(task1_mux_id);
             task1_mux_id = MUX_NULL;
             return;
@@ -219,5 +217,5 @@
     Serial.println((char*)buffer);
     
-    if(!wifi.send(task1_mux_id, buffer, len)) {
+    if(!WiFi.send(task1_mux_id, buffer, len)) {
         Serial.println("Echo Server Task1 : send(task1_mux_id, cmd) : Error!");
     }