Index: rtos_arduino/trunk/README.txt
===================================================================
--- rtos_arduino/trunk/README.txt	(revision 186)
+++ rtos_arduino/trunk/README.txt	(revision 222)
@@ -1,5 +1,5 @@
 =====================================================================
        TOPPERS RTE/RTOS compatible with Arduino libraries : R2CA  
-                                   Last Modified:2016 Mar 28 14:43:20
+                                   Last Modified:2016 Apr 27 01:11:18
 =====================================================================
 
@@ -173,5 +173,12 @@
   ã»NCESCAN : USE_NCESCAN
     
-æ¬¡ã®ã©ã¤ãã©ãªã¯åä½æªç¢ºèªã§ããï¼
+Wire(I2C)ã®æä»å¶å¾¡
+
+è¤æ°ã®ã¿ã¹ã¯ããWrireãä½¿ç¨ããå ´åã¯ï¼ä½¿ç¨ã®åå¾ã§ï¼ä»¥ä¸ã®ãã¯ã­ãå¼
+ã³åºãã¦æä»å¶å¾¡ãè¡ããã¨ï¼
+
+WIRE_ENTER_CRITICAL;
+WIRE_LEAVE_CRITICAL;
+
 
 âãã¡ã¤ã«
@@ -218,5 +225,15 @@
       ESP8266ãä½¿ç¨ãã¦Milkcocoaã«æ¥ç¶ããããã®ã©ã¤ãã©ãªï¼
       https://github.com/milk-cocoa/Milkcocoa_Arduino_SDK   
-      
+    ./thingspeak-arduino
+      ESP8266ãä½¿ç¨ãã¦Thingspeakã«æ¥ç¶ããããã®ã©ã¤ãã©ãªï¼    
+      https://github.com/mathworks/thingspeak-arduino
+    ./ArduinoJson
+      BuleMixã«æ¥ç¶ããããã®Jsonã©ã¤ãã©ãªï¼
+      https://github.com/bblanchon/ArduinoJson 
+      third-partyã®ãã©ã«ããåé¤
+    ./pubsubclient-2.6
+      BuleMixã«æ¥ç¶ããããã®Jsonã©ã¤ãã©ãªï¼
+      https://github.com/knolleary/pubsubclient/releases/tag/v2.6 
+
 ./asp_1.9.2
   ã»ASPã«ã¼ãã«ã®ã½ã¼ã¹ã³ã¼ã
@@ -229,4 +246,6 @@
 ./CompositeExample 
  ã»åç¨®æ©è½ãçµã¿åããããµã³ãã«
+./Milkcocoa_basic
+ ã»Milkcocoaã«æ¥ç¶ããåºæ¬çãªãµã³ãã«ï¼
 ./MultiTtask
  ã»ãã«ãã¿ã¹ã¯ã®ãµã³ãã«ï¼
@@ -239,5 +258,8 @@
 ./RRscheduling
  ã»ã©ã¦ã³ãã­ãã³ã¹ã±ã¸ã¥ã¼ãªã³ã°ã®ãµã³ãã«ï¼
-
+./ThingsSpeak_basic
+ ã»ThingsSpeakã«æ¥ç¶ããåºæ¬çãªãµã³ãã«ï¼
+./WifiEcho
+ ã»Wifiã®ãµã³ãã«ï¼
 
 âã³ã³ãã£ã®ã¥ã¬ã¼ã·ã§ã³é 
@@ -284,17 +306,26 @@
                åºåã¨ãªãï¼
       
-âArduinoã©ã¤ãã©ãªã¸ã®ããã : å¯¾è±¡ IDE 1.7.8
-
-âãã°
-./hardware/arduino/samd/cores/arduino/USB/samd21_device.c : 152è¡ç® ã¡ã¢ãªãªã¼ã¯
-
- 	for (i = 0; i < sizeof(usb_endpoint_table)/4; i++) {
- 		(*(uint32_t *)((uint32_t *)(&usb_endpoint_table[0])+i)) = 0;
- 	}
- 
-arduino/samd/variants/arduino_zero/variant.h : 68è¡ç®  å®ç¾©ãã¹
+âArduinoã©ã¤ãã©ãªã¸ã®ããã : å¯¾è±¡ IDE 1.7.10
+
+âãã° 
+./hardware/arduino/samd/variants/arduino_zero/variant.h : 68è¡ç®  å®ç¾©ãã¹
 #define portOutputRegister(port)   ( &(port->OUT.reg) )
 #define portInputRegister(port)    ( &(port->IN.reg) )
 
+./hardware/arduino/samd/cores/arduino/USB/samd21_host.c : ãã³ãã©åã®éè¤
+
+62è¡ç® å®ç¾©ã®è¿½å 
+ static void UHD_ISR(void);
+
+74è¡ç® ãã³ãã©åã®å¤æ´
+ USB_SetHandler(&UHD_ISR);
+ 
+177è¡ç® ãã³ãã©åã®å¤æ´
+ static void UHD_ISR(void)
+
+./hardware/arduino/samd/cores/arduino/Tone.cpp : 210/227è¡ç® ã¬ã¸ã¹ã¿ã¯ãªã¢
+      TCx->COUNT8.CTRLA.reg &= ~0x700;
+      TCCx->CTRLA.reg &= ~0x700;
+            
 libraries\TFT\src\utility\ããã¤ãã®ãã¡ã¤ã«
 ARDUINO_ARCH_SAM -> ARDUINO_ARCH_SAD
@@ -313,14 +344,4 @@
 
 
-hardware/arduino/samd/cores/arduino/wiring_analog.c
-å
-é ­ã«ä»¥ä¸ãè¿½å ï¼
-
-// Wait for synchronization of registers between the clock domains
-static __inline__ void syncDAC() __attribute__((always_inline, unused));
-static void syncDAC() {
-  while (DAC->STATUS.bit.SYNCBUSY == 1)
-    ;
-}
 
 âTOPPERSå¯¾å¿
@@ -349,4 +370,9 @@
 }
 
+/arduino_lib/libraries/SD/src/utility/Sd2Card.cpp
+SPIä½¿ç¨æã«ã»ããã©ãä½¿ç¨ããããå¤æ´ï¼
+
+
+
 âæ©è½è¿½å 
 
@@ -364,5 +390,5 @@
 ESP8266ã®éä¿¡ç¨ã«ãªã³ã°ãããã¡ãµã¤ãºãå¤§ããããï¼
 
-#define SERIAL_BUFFER_SIZE 256
+#define SERIAL_BUFFER_SIZE 1024
 
 