Index: rtos_arduino/trunk/examples/BlueMix_basic/rca_app.cpp
===================================================================
--- rtos_arduino/trunk/examples/BlueMix_basic/rca_app.cpp	(revision 234)
+++ rtos_arduino/trunk/examples/BlueMix_basic/rca_app.cpp	(revision 235)
@@ -5,8 +5,5 @@
 #include <ArduinoJson.h>
 
-#define ORGANIZATION	""		//gDID
-#define DEVICE_TYPE	""		//foCXE^Cv
-#define DEVICE_ID	""	//foCXID
-#define PASSWORD	""	//FØg[N
+#include "../examples_gdef.h"
 
 char serverName[] = ORGANIZATION ".messaging.internetofthings.ibmcloud.com";
@@ -18,7 +15,4 @@
 ESP8266Client wifi_client;
 PubSubClient client(serverName, 1883, 0, wifi_client);
-
-#define STA_SSID       ""
-#define STA_PASSWORD   ""
 
 void MqttConnect()
Index: rtos_arduino/trunk/examples/Milkcocoa_NCESIoT/rca_app.cpp
===================================================================
--- rtos_arduino/trunk/examples/Milkcocoa_NCESIoT/rca_app.cpp	(revision 234)
+++ rtos_arduino/trunk/examples/Milkcocoa_NCESIoT/rca_app.cpp	(revision 235)
@@ -4,9 +4,5 @@
 #include "Client_ESP8266.h"
 
-#define STA_SSID       ""
-#define STA_PASSWORD   ""
-
-#define MILKCOCOA_APP_ID      ""
-#define MILKCOCOA_DATASTORE   ""
+#include "../examples_gdef.h"
 
 #define MILKCOCOA_SERVERPORT  1883
Index: rtos_arduino/trunk/examples/Milkcocoa_basic/rca_app.cpp
===================================================================
--- rtos_arduino/trunk/examples/Milkcocoa_basic/rca_app.cpp	(revision 234)
+++ rtos_arduino/trunk/examples/Milkcocoa_basic/rca_app.cpp	(revision 235)
@@ -4,9 +4,5 @@
 #include "Client_ESP8266.h"
 
-#define STA_SSID       ""
-#define STA_PASSWORD   ""
-
-#define MILKCOCOA_APP_ID      ""
-#define MILKCOCOA_DATASTORE   ""
+#include "../examples_gdef.h"
 
 //#define MILKCOCOA_PUSH
Index: rtos_arduino/trunk/examples/ThingSpeak_basic/rca_app.cpp
===================================================================
--- rtos_arduino/trunk/examples/ThingSpeak_basic/rca_app.cpp	(revision 234)
+++ rtos_arduino/trunk/examples/ThingSpeak_basic/rca_app.cpp	(revision 235)
@@ -4,6 +4,5 @@
 #include "ThingSpeak.h"
 
-#define STA_SSID       ""
-#define STA_PASSWORD   ""
+#include "../examples_gdef.h"
 
 ESP8266Client wifi_client;
@@ -79,8 +78,15 @@
 }
 
-unsigned long myChannelNumber = 
-const char * myWriteAPIKey = "";
+unsigned long myChannelNumber =THINGSPEAK_CHANNELNUMBER ;
+const char * myWriteAPIKey = THINGSPEAK_WRITEAPIKEY ;
+
 int cnt1;
 int cnt2;
+
+#include <math.h>
+int a;
+float temperature;
+int B=3975;                  //B value of the thermistor
+float resistance;
 
 void loop() {
Index: rtos_arduino/trunk/examples/WifiEcho/rca_app.cpp
===================================================================
--- rtos_arduino/trunk/examples/WifiEcho/rca_app.cpp	(revision 234)
+++ rtos_arduino/trunk/examples/WifiEcho/rca_app.cpp	(revision 235)
@@ -2,9 +2,5 @@
 #include "ESP8266.h"
 
-#define STA_SSID       ""
-#define STA_PASSWORD   ""
-
-#define AP_SSID       "M0_AP"
-#define AP_PASSWORD   "none"
+#include "../examples_gdef.h"
 
 #define WMODE_STATION
@@ -28,5 +24,5 @@
         Serial.println(WiFi.getVersion().c_str());
         Serial.print("Supported FW Version:");
-        Serial.println(ESP8266_SUPPORT_VERSION);
+        Serial.print(ESP8266_SUPPORT_VERSION);
         while(1);
     } else {
@@ -50,4 +46,5 @@
     } else {
         Serial.print("Join AP failure\r\n");
+        while(1);
     }
 #else /* !WMODE_STATION */ 
@@ -71,4 +68,5 @@
     } else {
         Serial.print("multiple err\r\n");
+        while(1);
     }
 
@@ -77,4 +75,5 @@
     } else {
         Serial.print("start tcp server err\r\n");
+        while(1);
     }
 
@@ -83,4 +82,5 @@
     } else {
         Serial.print("set tcp server timout err\r\n");
+        while(1);
     }
 
Index: rtos_arduino/trunk/examples/examples_gdef.h
===================================================================
--- rtos_arduino/trunk/examples/examples_gdef.h	(revision 234)
+++ rtos_arduino/trunk/examples/examples_gdef.h	(revision 235)
@@ -4,6 +4,12 @@
  * For Wifi
  */
-#define STA_SSID       ""
-#define STA_PASSWORD   ""
+#define STA_SSID       "0024_MYNET"
+#define STA_PASSWORD   "yf-19_yf-21_plus"
+
+//#define STA_SSID       "RX501NC_0B8C"
+//#define STA_PASSWORD   "50229567"
+
+//#define STA_SSID       "ERTL_GLOBAL"
+//#define STA_PASSWORD   "ertl__toppers"
 
 #define AP_SSID       "M0_AP"
@@ -13,6 +19,6 @@
  * For Milkcocoa
  */
-#define MILKCOCOA_APP_ID      ""
-#define MILKCOCOA_DATASTORE   ""
+#define MILKCOCOA_APP_ID      "uniim5nqwug"
+#define MILKCOCOA_DATASTORE   "R2CA_DATA"
 
 /*
@@ -27,6 +33,6 @@
  * For ThingSpeak
  */
-#define THINGSPEAK_CHANNELNUMBER
-#define THINGSPEAK_WRITEAPIKEY 
+#define THINGSPEAK_CHANNELNUMBER 103978
+#define THINGSPEAK_WRITEAPIKEY  "D1G413IIE3QBNWGG"
 
 #endif /* _WIFI_SETTING_H_ */