Index: /rc_autosar_rh850/trunk/os-application/obj/configure.mtpj
===================================================================
--- /rc_autosar_rh850/trunk/os-application/obj/configure.mtpj	(revision 238)
+++ /rc_autosar_rh850/trunk/os-application/obj/configure.mtpj	(revision 239)
@@ -205,5 +205,5 @@
     </Instance>
     <Instance Guid="1268cda7-f509-4a4f-8552-a413adafabfb">
-      <DeviceName>R7F701035xAFP</DeviceName>
+      <DeviceName>R7F701025xAFP</DeviceName>
       <MemoCount>0</MemoCount>
     </Instance>
Index: /rc_autosar_rh850/trunk/swc-application/1ecu/ecu_cbo/configure.mtpj
===================================================================
--- /rc_autosar_rh850/trunk/swc-application/1ecu/ecu_cbo/configure.mtpj	(revision 238)
+++ /rc_autosar_rh850/trunk/swc-application/1ecu/ecu_cbo/configure.mtpj	(revision 239)
@@ -205,5 +205,5 @@
     </Instance>
     <Instance Guid="1268cda7-f509-4a4f-8552-a413adafabfb">
-      <DeviceName>R7F701035xAFP</DeviceName>
+      <DeviceName>R7F701025xAFP</DeviceName>
       <MemoCount>0</MemoCount>
     </Instance>
Index: /rc_autosar_rh850/trunk/swc-application/2ecu_co_b/ecu_b/configure.mtpj
===================================================================
--- /rc_autosar_rh850/trunk/swc-application/2ecu_co_b/ecu_b/configure.mtpj	(revision 238)
+++ /rc_autosar_rh850/trunk/swc-application/2ecu_co_b/ecu_b/configure.mtpj	(revision 239)
@@ -32,5 +32,5 @@
     </Instance>
     <Instance Guid="1268cda7-f509-4a4f-8552-a413adafabfb">
-      <DeviceName>R7F701035xAFP</DeviceName>
+      <DeviceName>R7F701025xAFP</DeviceName>
       <MemoCount>0</MemoCount>
     </Instance>
Index: /rc_autosar_rh850/trunk/swc-application/2ecu_co_b/ecu_co/configure.mtpj
===================================================================
--- /rc_autosar_rh850/trunk/swc-application/2ecu_co_b/ecu_co/configure.mtpj	(revision 238)
+++ /rc_autosar_rh850/trunk/swc-application/2ecu_co_b/ecu_co/configure.mtpj	(revision 239)
@@ -205,5 +205,5 @@
     </Instance>
     <Instance Guid="1268cda7-f509-4a4f-8552-a413adafabfb">
-      <DeviceName>R7F701035xAFP</DeviceName>
+      <DeviceName>R7F701025xAFP</DeviceName>
       <MemoCount>0</MemoCount>
     </Instance>
Index: /rc_autosar_rh850/trunk/swc-application/2ecu_cod_b/ecu_b/configure.mtpj
===================================================================
--- /rc_autosar_rh850/trunk/swc-application/2ecu_cod_b/ecu_b/configure.mtpj	(revision 238)
+++ /rc_autosar_rh850/trunk/swc-application/2ecu_cod_b/ecu_b/configure.mtpj	(revision 239)
@@ -32,5 +32,5 @@
     </Instance>
     <Instance Guid="1268cda7-f509-4a4f-8552-a413adafabfb">
-      <DeviceName>R7F701035xAFP</DeviceName>
+      <DeviceName>R7F701025xAFP</DeviceName>
       <MemoCount>0</MemoCount>
     </Instance>
Index: /rc_autosar_rh850/trunk/swc-application/2ecu_cod_b/ecu_cod/configure.mtpj
===================================================================
--- /rc_autosar_rh850/trunk/swc-application/2ecu_cod_b/ecu_cod/configure.mtpj	(revision 238)
+++ /rc_autosar_rh850/trunk/swc-application/2ecu_cod_b/ecu_cod/configure.mtpj	(revision 239)
@@ -205,5 +205,5 @@
     </Instance>
     <Instance Guid="1268cda7-f509-4a4f-8552-a413adafabfb">
-      <DeviceName>R7F701035xAFP</DeviceName>
+      <DeviceName>R7F701025xAFP</DeviceName>
       <MemoCount>0</MemoCount>
     </Instance>
Index: /rc_autosar_rh850/trunk/swc-application/2ecu_od_cb/ecu_cb/configure.mtpj
===================================================================
--- /rc_autosar_rh850/trunk/swc-application/2ecu_od_cb/ecu_cb/configure.mtpj	(revision 238)
+++ /rc_autosar_rh850/trunk/swc-application/2ecu_od_cb/ecu_cb/configure.mtpj	(revision 239)
@@ -32,5 +32,5 @@
     </Instance>
     <Instance Guid="1268cda7-f509-4a4f-8552-a413adafabfb">
-      <DeviceName>R7F701035xAFP</DeviceName>
+      <DeviceName>R7F701025xAFP</DeviceName>
       <MemoCount>0</MemoCount>
     </Instance>
Index: /rc_autosar_rh850/trunk/swc-application/2ecu_od_cb/ecu_od/configure.mtpj
===================================================================
--- /rc_autosar_rh850/trunk/swc-application/2ecu_od_cb/ecu_od/configure.mtpj	(revision 238)
+++ /rc_autosar_rh850/trunk/swc-application/2ecu_od_cb/ecu_od/configure.mtpj	(revision 239)
@@ -205,5 +205,5 @@
     </Instance>
     <Instance Guid="1268cda7-f509-4a4f-8552-a413adafabfb">
-      <DeviceName>R7F701035xAFP</DeviceName>
+      <DeviceName>R7F701025xAFP</DeviceName>
       <MemoCount>0</MemoCount>
     </Instance>
Index: /rc_autosar_rh850/trunk/swc-application/3ecu/ecu_b/configure.mtpj
===================================================================
--- /rc_autosar_rh850/trunk/swc-application/3ecu/ecu_b/configure.mtpj	(revision 238)
+++ /rc_autosar_rh850/trunk/swc-application/3ecu/ecu_b/configure.mtpj	(revision 239)
@@ -32,5 +32,5 @@
     </Instance>
     <Instance Guid="1268cda7-f509-4a4f-8552-a413adafabfb">
-      <DeviceName>R7F701035xAFP</DeviceName>
+      <DeviceName>R7F701025xAFP</DeviceName>
       <MemoCount>0</MemoCount>
     </Instance>
Index: /rc_autosar_rh850/trunk/swc-application/3ecu/ecu_c/configure.mtpj
===================================================================
--- /rc_autosar_rh850/trunk/swc-application/3ecu/ecu_c/configure.mtpj	(revision 238)
+++ /rc_autosar_rh850/trunk/swc-application/3ecu/ecu_c/configure.mtpj	(revision 239)
@@ -32,5 +32,5 @@
     </Instance>
     <Instance Guid="1268cda7-f509-4a4f-8552-a413adafabfb">
-      <DeviceName>R7F701035xAFP</DeviceName>
+      <DeviceName>R7F701025xAFP</DeviceName>
       <MemoCount>0</MemoCount>
     </Instance>
Index: /rc_autosar_rh850/trunk/swc-application/3ecu/ecu_od/configure.mtpj
===================================================================
--- /rc_autosar_rh850/trunk/swc-application/3ecu/ecu_od/configure.mtpj	(revision 238)
+++ /rc_autosar_rh850/trunk/swc-application/3ecu/ecu_od/configure.mtpj	(revision 239)
@@ -205,5 +205,5 @@
     </Instance>
     <Instance Guid="1268cda7-f509-4a4f-8552-a413adafabfb">
-      <DeviceName>R7F701035xAFP</DeviceName>
+      <DeviceName>R7F701025xAFP</DeviceName>
       <MemoCount>0</MemoCount>
     </Instance>