Index: autosar_os_training/trunk/program/sample/sample1.arxml
===================================================================
--- autosar_os_training/trunk/program/sample/sample1.arxml	(revision 124)
+++ autosar_os_training/trunk/program/sample/sample1.arxml	(revision 258)
@@ -1,4 +1,4 @@
-<?xml version="1.0" encoding="EUC-JP"?>
-<!-- Generated by ABREX Ver. 1.0.0 -->
+<?xml version="1.0" encoding="UTF-8"?>
+<!-- Generated by ABREX Ver. 1.1.0 -->
 <AUTOSAR xmlns="http://autosar.org/schema/r4.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://autosar.org/schema/r4.0 AUTOSAR_4-0-3_STRICT.xsd">
 	<AR-PACKAGES>
@@ -126,5 +126,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsCounter/OsCounterMaxAllowedValue</DEFINITION-REF>
-									<VALUE>99U</VALUE>
+									<VALUE>99</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-NUMERICAL-PARAM-VALUE>
@@ -134,5 +134,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsCounter/OsCounterTicksPerBase</DEFINITION-REF>
-									<VALUE>10U</VALUE>
+									<VALUE>10</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-TEXTUAL-PARAM-VALUE>
@@ -148,5 +148,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsTask/OsTaskActivation</DEFINITION-REF>
-									<VALUE>1U</VALUE>
+									<VALUE>1</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-NUMERICAL-PARAM-VALUE>
@@ -196,5 +196,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsTask/OsTaskActivation</DEFINITION-REF>
-									<VALUE>1U</VALUE>
+									<VALUE>1</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-NUMERICAL-PARAM-VALUE>
@@ -218,5 +218,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsTask/OsTaskActivation</DEFINITION-REF>
-									<VALUE>8U</VALUE>
+									<VALUE>8</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-NUMERICAL-PARAM-VALUE>
@@ -240,5 +240,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsTask/OsTaskActivation</DEFINITION-REF>
-									<VALUE>8U</VALUE>
+									<VALUE>8</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-NUMERICAL-PARAM-VALUE>
@@ -288,5 +288,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsTask/OsTaskActivation</DEFINITION-REF>
-									<VALUE>1U</VALUE>
+									<VALUE>1</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-NUMERICAL-PARAM-VALUE>
@@ -330,5 +330,5 @@
 								<ECUC-CONTAINER-VALUE>
 									<SHORT-NAME>OsAlarmAction</SHORT-NAME>
-									<DEFINITION-REF DEST="ECUC-PARAM-CONF-CONTAINER-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAction</DEFINITION-REF>
+									<DEFINITION-REF DEST="ECUC-CHOICE-CONTAINER-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAction</DEFINITION-REF>
 									<SUB-CONTAINERS>
 										<ECUC-CONTAINER-VALUE>
@@ -362,5 +362,5 @@
 								<ECUC-CONTAINER-VALUE>
 									<SHORT-NAME>OsAlarmAction</SHORT-NAME>
-									<DEFINITION-REF DEST="ECUC-PARAM-CONF-CONTAINER-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAction</DEFINITION-REF>
+									<DEFINITION-REF DEST="ECUC-CHOICE-CONTAINER-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAction</DEFINITION-REF>
 									<SUB-CONTAINERS>
 										<ECUC-CONTAINER-VALUE>
@@ -390,5 +390,5 @@
 								<ECUC-CONTAINER-VALUE>
 									<SHORT-NAME>OsAlarmAction</SHORT-NAME>
-									<DEFINITION-REF DEST="ECUC-PARAM-CONF-CONTAINER-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAction</DEFINITION-REF>
+									<DEFINITION-REF DEST="ECUC-CHOICE-CONTAINER-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAction</DEFINITION-REF>
 									<SUB-CONTAINERS>
 										<ECUC-CONTAINER-VALUE>
@@ -422,5 +422,5 @@
 								<ECUC-CONTAINER-VALUE>
 									<SHORT-NAME>OsAlarmAction</SHORT-NAME>
-									<DEFINITION-REF DEST="ECUC-PARAM-CONF-CONTAINER-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAction</DEFINITION-REF>
+									<DEFINITION-REF DEST="ECUC-CHOICE-CONTAINER-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAction</DEFINITION-REF>
 									<SUB-CONTAINERS>
 										<ECUC-CONTAINER-VALUE>
@@ -452,5 +452,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsTask/OsTaskActivation</DEFINITION-REF>
-									<VALUE>1U</VALUE>
+									<VALUE>1</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-NUMERICAL-PARAM-VALUE>
@@ -496,5 +496,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsTask/OsTaskActivation</DEFINITION-REF>
-									<VALUE>5U</VALUE>
+									<VALUE>5</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-NUMERICAL-PARAM-VALUE>
@@ -558,5 +558,5 @@
 								<ECUC-CONTAINER-VALUE>
 									<SHORT-NAME>OsAlarmAction</SHORT-NAME>
-									<DEFINITION-REF DEST="ECUC-PARAM-CONF-CONTAINER-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAction</DEFINITION-REF>
+									<DEFINITION-REF DEST="ECUC-CHOICE-CONTAINER-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAction</DEFINITION-REF>
 									<SUB-CONTAINERS>
 										<ECUC-CONTAINER-VALUE>
@@ -578,9 +578,9 @@
 										<ECUC-NUMERICAL-PARAM-VALUE>
 											<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAutostart/OsAlarmAlarmTime</DEFINITION-REF>
-											<VALUE>10U</VALUE>
+											<VALUE>10</VALUE>
 										</ECUC-NUMERICAL-PARAM-VALUE>
 										<ECUC-NUMERICAL-PARAM-VALUE>
 											<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAutostart/OsAlarmCycleTime</DEFINITION-REF>
-											<VALUE>10U</VALUE>
+											<VALUE>10</VALUE>
 										</ECUC-NUMERICAL-PARAM-VALUE>
 										<ECUC-TEXTUAL-PARAM-VALUE>
@@ -612,5 +612,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsScheduleTable/OsScheduleTableDuration</DEFINITION-REF>
-									<VALUE>60U</VALUE>
+									<VALUE>60</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-NUMERICAL-PARAM-VALUE>
@@ -740,5 +740,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsTask/OsTaskActivation</DEFINITION-REF>
-									<VALUE>5U</VALUE>
+									<VALUE>5</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-NUMERICAL-PARAM-VALUE>
@@ -786,5 +786,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsScheduleTable/OsScheduleTableDuration</DEFINITION-REF>
-									<VALUE>50U</VALUE>
+									<VALUE>50</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-NUMERICAL-PARAM-VALUE>
@@ -902,5 +902,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsTask/OsTaskActivation</DEFINITION-REF>
-									<VALUE>1U</VALUE>
+									<VALUE>1</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-NUMERICAL-PARAM-VALUE>
@@ -936,5 +936,5 @@
 								<ECUC-CONTAINER-VALUE>
 									<SHORT-NAME>OsAlarmAction</SHORT-NAME>
-									<DEFINITION-REF DEST="ECUC-PARAM-CONF-CONTAINER-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAction</DEFINITION-REF>
+									<DEFINITION-REF DEST="ECUC-CHOICE-CONTAINER-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAction</DEFINITION-REF>
 									<SUB-CONTAINERS>
 										<ECUC-CONTAINER-VALUE>
@@ -956,9 +956,9 @@
 										<ECUC-NUMERICAL-PARAM-VALUE>
 											<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAutostart/OsAlarmAlarmTime</DEFINITION-REF>
-											<VALUE>10U</VALUE>
+											<VALUE>10</VALUE>
 										</ECUC-NUMERICAL-PARAM-VALUE>
 										<ECUC-NUMERICAL-PARAM-VALUE>
 											<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAutostart/OsAlarmCycleTime</DEFINITION-REF>
-											<VALUE>10U</VALUE>
+											<VALUE>10</VALUE>
 										</ECUC-NUMERICAL-PARAM-VALUE>
 										<ECUC-TEXTUAL-PARAM-VALUE>
@@ -990,5 +990,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsTask/OsTaskActivation</DEFINITION-REF>
-									<VALUE>1U</VALUE>
+									<VALUE>1</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-NUMERICAL-PARAM-VALUE>
@@ -1018,5 +1018,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsCounter/OsCounterMaxAllowedValue</DEFINITION-REF>
-									<VALUE>99U</VALUE>
+									<VALUE>99</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-NUMERICAL-PARAM-VALUE>
@@ -1026,5 +1026,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsCounter/OsCounterTicksPerBase</DEFINITION-REF>
-									<VALUE>10U</VALUE>
+									<VALUE>10</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-TEXTUAL-PARAM-VALUE>
@@ -1046,5 +1046,5 @@
 								<ECUC-CONTAINER-VALUE>
 									<SHORT-NAME>OsAlarmAction</SHORT-NAME>
-									<DEFINITION-REF DEST="ECUC-PARAM-CONF-CONTAINER-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAction</DEFINITION-REF>
+									<DEFINITION-REF DEST="ECUC-CHOICE-CONTAINER-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAction</DEFINITION-REF>
 									<SUB-CONTAINERS>
 										<ECUC-CONTAINER-VALUE>
@@ -1066,9 +1066,9 @@
 										<ECUC-NUMERICAL-PARAM-VALUE>
 											<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAutostart/OsAlarmAlarmTime</DEFINITION-REF>
-											<VALUE>10U</VALUE>
+											<VALUE>10</VALUE>
 										</ECUC-NUMERICAL-PARAM-VALUE>
 										<ECUC-NUMERICAL-PARAM-VALUE>
 											<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsAlarm/OsAlarmAutostart/OsAlarmCycleTime</DEFINITION-REF>
-											<VALUE>10U</VALUE>
+											<VALUE>10</VALUE>
 										</ECUC-NUMERICAL-PARAM-VALUE>
 										<ECUC-TEXTUAL-PARAM-VALUE>
@@ -1100,5 +1100,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsTask/OsTaskActivation</DEFINITION-REF>
-									<VALUE>1U</VALUE>
+									<VALUE>1</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-NUMERICAL-PARAM-VALUE>
@@ -1128,5 +1128,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsCounter/OsCounterMaxAllowedValue</DEFINITION-REF>
-									<VALUE>99U</VALUE>
+									<VALUE>99</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-NUMERICAL-PARAM-VALUE>
@@ -1136,5 +1136,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsCounter/OsCounterTicksPerBase</DEFINITION-REF>
-									<VALUE>10U</VALUE>
+									<VALUE>10</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-TEXTUAL-PARAM-VALUE>
@@ -1150,5 +1150,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsCounter/OsCounterMaxAllowedValue</DEFINITION-REF>
-									<VALUE>99U</VALUE>
+									<VALUE>99</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-NUMERICAL-PARAM-VALUE>
@@ -1158,5 +1158,5 @@
 								<ECUC-NUMERICAL-PARAM-VALUE>
 									<DEFINITION-REF DEST="ECUC-INTEGER-PARAM-DEF">/AUTOSAR/EcucDefs/Os/OsCounter/OsCounterTicksPerBase</DEFINITION-REF>
-									<VALUE>10U</VALUE>
+									<VALUE>10</VALUE>
 								</ECUC-NUMERICAL-PARAM-VALUE>
 								<ECUC-TEXTUAL-PARAM-VALUE>